class DSConfig {
    debug = false;
}

// js与客户端交互的中间层
class DataScienceJsObj {
    //id和回调的对应关系
    callbacks = new Map();

    //客户端回调js方法
    sendNativeResult(id, func, args) {
        console.log('js 执行sendNativeResult')
        if (this.callbacks != null) {
            console.log('js  callbacks ！= null')
            let obj = this.callbacks.get(id)
            if (obj) {
                if (obj[func]) {
                    obj[func](args)
                }
                this.callbacks.delete(id)
            }
        }
    }

    //调用客户端方法
     callNativeMethod(params) {
        console.log('js 执行callNativeMethod')
        params.id = new Date().toDateString()
        this.callbacks.set(params.id, params)
        if (window.cloudH5) {
            let json = JSON.stringify(params)
            window.cloudH5.execute(params.method, json)
        }
     }
}


class DSCallback {

    success = null;
    failure = null;
    error = null;

    constructor(success, failure, error) {
        this.success = success;
        this.failure = failure;
        this.error = error;
    }

}


const cloud = new DataScienceJsObj()


//客户端回调js
window.handNative = function (params) {
    console.log('js handNative called params =', params)
    let obj = JSON.parse(params)
    let id = obj.id;
    let func = obj.func;
    let args = obj.args;
    if (cloud != null) {
        cloud.sendNativeResult(id, func, args);
    }
}

